<template>
  <div>
    <base-dialog
      :show="!!error"
      title="An Error Occured"
      @close="handleError"
      >{{ error }}</base-dialog
    >
    <base-dialog fixed :show="isLoading" title="Authenticating...">
      <base-spinner></base-spinner>
    </base-dialog>
    <base-card>
      <form @submit.prevent="submitForm">
        <div class="form-control" :class="{ invalid: !email.isValid }">
          <label for="email">Email</label>
          <input type="email" id="email" v-model.trim="email.value" />
          <small v-if="!email.isValid"
            >Please enter proper Email with '@' symbol</small
          >
        </div>
        <div class="form-control" :class="{ invalid: !password.isValid }">
          <label for="password">Password</label>
          <input type="password" id="password" v-model.trim="password.value" />
          <small v-if="!password.isValid"
            >Password length should be minimum 6 characters</small
          >
        </div>
        <base-button>{{ submitButtonCaption }}</base-button>
        <base-button type="button" mode="flat" @click="switchMode"
          >{{ switchButtonCaption }} Instead</base-button
        >
      </form>
      <small v-if="!formIsValid">Please Check your Inputs</small>
    </base-card>
  </div>
</template>

<script>
export default {
  data: function() {
    return {
      email: {
        value: '',
        isValid: true
      },
      password: {
        value: '',
        isValid: true
      },
      formIsValid: true,
      mode: 'login',
      isLoading: false,
      error: null
    };
  },
  computed: {
    submitButtonCaption: function() {
      if (this.mode === 'login') return 'Log In';
      else return 'Sign Up';
    },
    switchButtonCaption: function() {
      if (this.mode === 'signup') return 'Log In';
      else return 'Sign Up';
    }
  },
  methods: {
    validateFrom: function() {
      if (this.email.value === '' || !this.email.value.includes('@')) {
        console.log('email invalid');
        this.email.isValid = false;
        this.formIsValid = false;
      } else {
        this.email.isValid = true;
        this.formIsValid = true;
      }
      if (this.password.value === '' || this.password.value.length < 6) {
        console.log('password invalid');
        this.password.isValid = false;
        this.formIsValid = false;
      } else {
        this.password.isValid = true;
        this.formIsValid = true;
      }
    },
    submitForm: async function() {
      this.formIsValid = true;
      this.validateFrom();

      if (!this.formIsValid) return;
      const actionPayload = {
        email: this.email.value,
        password: this.password.value
      };
      this.isLoading = true;
      try {
        if (this.mode === 'login') {
          await this.$store.dispatch('login', actionPayload);
        } else {
          await this.$store.dispatch('signup', actionPayload);
        }
        const redirectUrl = `/${this.$route.query.redirect || 'coaches'}`;
        this.$router.replace(redirectUrl);
      } catch (err) {
        this.error = err.message || 'Failed to authenticate';
      }
      this.isLoading = false;
    },
    switchMode: function() {
      if (this.mode === 'login') this.mode = 'signup';
      else this.mode = 'login';
    },
    handleError: function() {
      this.error = null;
    }
  }
};
</script>

<style scoped>
form {
  margin: 1rem;
  padding: 1rem;
}

.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  margin-bottom: 0.5rem;
  display: block;
}

input {
  display: block;
  width: 100%;
  border: 1px solid rgba(0, 0, 0, 0.4);
  font: inherit;
  padding: 0.5rem;
  border-radius: 4px;
  transition: all 0.2s;
}

input:focus,
textarea:focus {
  border-color: #3e88a7;
  background-color: #3e88a718;
  outline: none;
}

.invalid label,
.invalid small {
  color: red;
}

.invalid input {
  border: 1px solid red;
}
</style>
